/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.repository.web.ui.internal.wizard.WizardStepList");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

var checkNotEmpty = net.jazz.ajax.toolbox.lang.checkNotEmpty;

function getStepLink(action, title, index) {
	checkNotEmpty(action, "action");
	checkNotEmpty(title, "title");
	
	var aElement = document.createElement("a");
	aElement.href = "#action=" + action;
	aElement.innerHTML = "<span class=\"number\">" + index + "</span><span class=\"sectionLabel\">" + title +"</span>";;
	
	return aElement;
}

function getStepInactiveLink(title, index) {
	checkNotEmpty(title, "title");
	
	var divElement = document.createElement("div");
	divElement.className = "inactiveStep";
	divElement.innerHTML = "<span class=\"number\">" + index + "</span><span class=\"sectionLabel\">" + title + "</span>";;
	
	return divElement;
}

dojo.declare("com.ibm.team.repository.web.ui.internal.wizard.WizardStepList", [dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/wizard/templates/WizardStepList.html"),
	postCreate: function() {
		WizardStepList.superclass.postCreate.apply(this);
		this._linkPrefix = this.prefix;
	},
	
	addStep: function(action){
		var index = this._wizardSteps.childNodes.length + 1;
		var step;
		if (action.active) {
			step = this.createActiveStepElement(action, index);
		} else {
			step = getStepInactiveLink(action.label, index);
		}
		step.__jazzActionId = action.shortId;
		this._wizardSteps.appendChild(step);
		
	}, 
	
	createActiveStepElement: function (action, index) {
		var id = this._linkPrefix + action.shortId;
		var link = getStepLink(id, action.label, index);
		return link;
	},
	
	activateStep: function (action, refWizard, prefix) {
		var steps = refWizard._stepSection.getElementsByTagName("DIV");
		var oldStep;
		for (var i=0; i < steps.length; i++) {
		 	if (steps[i].__jazzActionId === action.shortId) {
				oldStep = steps[i];
				break;			
			}		
		}
		var index = oldStep.firstChild.innerHTML;
		var newStep = refWizard._stepList.createActiveStepElement(action, index);
		newStep.__jazzActionId = action.shortId;
		oldStep.parentNode.replaceChild(newStep, oldStep);
	}
	
});

var WizardStepList = com.ibm.team.repository.web.ui.internal.wizard.WizardStepList;

})();